import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Vector;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.BitSet;

public class Main {
	
  private static final long MEGABYTE = 1024L * 1024L;

  public static long bytesToMegabytes(long bytes) {
    return bytes / MEGABYTE;
  }
  
  
  /* BLOOM FILTER */
  private class BloomFilter{
	
	int m; //array length
	BitSet bf; //Bloom Filter array of length m
	
	public BloomFilter(int m){
		this.m=m;
		this.bf=new BitSet(m);
	}

  
        private int hash1(String str){
		int hash=0;
        	for (int i = 0; i < str.length(); i++) {
			if(str.charAt(i)=='A' || str.charAt(i)=='C'){
				hash += (int)Math.pow(2,i);
			}
		}
		return hash % this.m;
        }
        
        private int hash2(String str){
		int hash=0;
        
        	for (int i = 0; i < str.length(); i++) {
			if(str.charAt(i)=='A' || str.charAt(i)=='G'){
				hash += (int)Math.pow(2,i);
			}
		}
		return hash % this.m;
        }
  

	/* Set bits to one, according to hash functions */
	private void add(String s){
		// TODO
	}

	/* Read bits from arrray according to hash functions.
	   Return false if and only if String s cannot have been inserted,
	   return true if String s might have been inserted.*/
	private Boolean mayContain(String s){
		// TODO
	}

  } // END OF BLOOM FILTER 

  
	/* Read noLines number of lines from each entry in the given multiple FASTA file. */
	public static Vector<String> readMultipleFasta(String filename, int noLines) {
		File file = new File(filename);
		String line = null;
		Vector<String> sequences = new Vector<String>();
		int i=0;
		try {
			BufferedReader br = new BufferedReader(new FileReader(file));
			String sequence=null;
			// Lies Datei zeilenweise
			while((line=br.readLine())!=null){
				// Fasta-header gefunden?
				if(line.startsWith(">")){
					if(sequence!=null){
						// Speichere aktuelle Sequenz
						sequences.add(sequence);
					}
					// Initiiere neue Sequenz
					sequence="";
					i=0;
				}else{
					// erweitere aktuelle Sequenz
					sequence+=line.trim();
					// enough lines read?
					if(++i>=noLines) break;
				}
			}
			// Speichere letzte Sequenz
			sequences.add(sequence);
			br.close();
		}catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
		return sequences;
	}

	
	
	public static long getMemory(){
		// Get the Java runtime
		Runtime runtime = Runtime.getRuntime();
		// Run the garbage collector
		runtime.gc();
		// Calculate the used memory
		return runtime.totalMemory() - runtime.freeMemory();
	}
	
	
	


	/**
	 * @param args
	 */
	public static void main(String[] args) {
	
		// SUFFIX TREE EXPERIMENT

		// read 750 lines of chromosome 20
		String s=readMultipleFasta("chr20.substring.fa",750).get(0);
		
		// Output header
		System.out.println("LEN\tMEM\tTIME");
	
		// for prefixes of the input string of various length (in steps of 500):
		int step=500;
		for(int i=step;i<s.length();i+=step){
			String substring=s.substring(0,i);
			// How much memory is used before the suffix tree is built?
			long baseMem =  getMemory();
			// measure time
			long startTime = System.currentTimeMillis();
			// build tree
			// TODO
			// input substring
			// TODO
			// make substring deletable for garbage collector
			substring=null;
			// output time and memory
			// TODO
			// make suffix tree removable for garbage collector
			in=null;
		}

		
		
		// BLOOM FILTER EXPERIMENT
		
		// read 10 lines of chromosome 20
		s=readMultipleFasta("chr20.substring.fa",10).get(0);
		
		// k-mer size 12
		int k=12;
		
		// init bloom filter
		Main.BloomFilter bf=new Main().new BloomFilter(4096);
		// add all k-mers from s
		for(int i=0;i<s.length()-k+1;i++){
			String kMer=s.substring(i,i+k);
			bf.add(kMer);
		}
		
		//save string also in suffix tree
		GeneralizedSuffixTree st = new GeneralizedSuffixTree();
		st.put(s,0);
		
		
		// True positive, false positive, negative?
		
		String kMer1="TTCCAAGAAAGG";
		String kMer2="AAAGACAGGTCG";
		String kMer3="AAATACAGGTCG";
		String kMer4="GAATACAGGTCG";
		String kMer5="CAAGACAGGTCG";
		String kMer6="GTATGCTCCAGG";
		
		// TODO...

	}

}

